// COGlobalVariable.cpp:      DLL.
//

#include "stdafx.h"
#include "GlobalVariable.h"
#include "Registry.h"
#include "BinaryLoader.h"
#include "Factory.h"

extern "C" IUnknown* CreateInstance()
{
	IUnknown* pI = static_cast<IGVData*>(new CGlobalVariable);
	pI->AddRef();
	return pI;
}


// Friendly name of component
CString g_szFriendlyName = _T("_GlobalVariable_");

// Version-independent ProgID
CString g_szVerIndProgID = _T("GlobalVariable.GlobalVariable");

// ProgID
CString g_szProgID = _T("GlobalVariable.GlobalVariable.1") ;

STDAPI DllRegisterServer()
{
	WCHAR buf[255];
	DWORD res = GetTempPath(255, buf);
	if(res > 0)
	{
		CString fName = CString(buf) + _T("\\MHandle.tmp");
		BinaryLoader reader(fName);
		int sizehModule_h = reader.ReadInt();
		int sizehModule_v = reader.ReadInt();
		if(sizehModule_h == sizeof(long))
		{
			long id1 = reader.ReadLong();
			long id2 = reader.ReadLong();
			g_hModule =  HMODULE(id1);
		}

		if(sizehModule_h == sizeof(long long))
		{
			long long id1 = reader.Read_INT64();
			long long id2 = reader.Read_INT64();
			g_hModule =  HMODULE(id1);
		}
		
		reader.Close();
	}	

	return RegisterServer(g_hModule, 
		CLSID_CGlobalVariable,
		g_szFriendlyName,
		g_szVerIndProgID,
		g_szProgID) ;
}

STDAPI DllUnregisterServer()
{
	return UnregisterServer(CLSID_CGlobalVariable,
		g_szVerIndProgID,
		g_szProgID) ;
}

STDAPI DllGetClassObject(	const CLSID& clsid,	const IID& iid,	void** ppv )
{
	if (clsid != CLSID_CGlobalVariable)
	{
		return CLASS_E_CLASSNOTAVAILABLE;
	}
	//   
	CFactory* pFactory = new CFactory(); //   
	//    1
	if (pFactory == NULL)
	{
		return E_OUTOFMEMORY;
	}	

	//   
	HRESULT hr = pFactory->QueryInterface(iid, ppv);
	pFactory->Release();
	return hr;
}

STDAPI DllCanUnloadNow()
{
	if ((g_cComponents == 0) && (g_cServerLocks == 0))
	{
		return S_OK;
	}
	else
	{
		return S_FALSE;
	}
}


