#include "StdAfx.h"
#include "Factory.h"
#include "GlobalVariable.h"

CGlobalVariable* g_pGV = NULL;
static bool FirstCall = false;


CFactory::CFactory(void)
{
	m_cRef = 1;
}

CFactory::~CFactory(void)
{
	g_pGV = NULL;
}

HRESULT __stdcall CFactory::QueryInterface( const IID& iid, void** ppv )
{
	if ((iid == IID_IUnknown) || (iid == IID_IClassFactory))
	{
		*ppv = static_cast<IClassFactory*>(this);
	}
	else
	{
		*ppv = NULL;
		return E_NOINTERFACE;
	}
	reinterpret_cast<IUnknown*>(*ppv)->AddRef();
	return S_OK;
}

ULONG __stdcall CFactory::AddRef()
{
		return InterlockedIncrement(&m_cRef);
}

ULONG __stdcall CFactory::Release()
{
	if (InterlockedDecrement(&m_cRef) == 0)
	{
		delete this;
		delete g_pGV;
		g_pGV = NULL;
		FirstCall = false;

		return 0;
	}
	return m_cRef;
}

HRESULT __stdcall CFactory::CreateInstance( IUnknown* pUnknownOuter, const IID& iid, void** ppv )
{
	if (pUnknownOuter != NULL)
	{
		return CLASS_E_NOAGGREGATION;
	}
	//  
	if(!FirstCall)
	{
		g_pGV = new CGlobalVariable();
		FirstCall = true;
	}
		//CGlobalVariable* pGV = new CGlobalVariable;
	if (g_pGV == NULL)
	{
		return E_OUTOFMEMORY;
	}

	//   
	HRESULT hr = g_pGV->QueryInterface(iid, ppv);

	return hr;
}
// LockServer
HRESULT __stdcall CFactory::LockServer(BOOL bLock)
{
	if (bLock)
	{
		InterlockedIncrement(&g_cServerLocks);
	}
	else
	{
		InterlockedDecrement(&g_cServerLocks);
	}
	return S_OK;
}

