#ifndef _GLOBALVARIABLE_H
#define _GLOBALVARIABLE_H

typedef pair<CString, UnionDATATYPE> IntVariables;



class CGlobalVariable: public IGVData
{
public:
public:
	CGlobalVariable();
	~CGlobalVariable();

	virtual HRESULT __stdcall QueryInterface(const IID& iid, void** ppv);
	virtual ULONG __stdcall AddRef();
	virtual ULONG __stdcall Release();

	virtual bool SetDataInt(CString name, int _value);
	virtual int GetDataInt(CString name);

	virtual bool SetDataLong(CString name, long _value);
	virtual long GetDataLong(CString name);

	virtual bool SetDataFloat(CString name, float _value);
	virtual float GetDataFloat(CString name);

	virtual bool SetDataDouble(CString name, double _value);
	virtual double GetDataDouble(CString name);

	virtual bool SetDataString(CString name, CString _value);
	virtual CString GetDataString(CString name);

	


private:
	bool ContainsKeyInIntMap(CString key);
	bool EraceElement(vector<IntVariables>::iterator _e);
	vector<IntVariables>::iterator GetElement(CString Name);
	CString GetKey(CString Name, CString Prefix);
	virtual bool RemoveAllVariables();
	
	long m_cRef;

	vector<IntVariables>	m_IntMap;

	CRITICAL_SECTION			m_Guard;
};

#endif