// COGlobalVariableWrapper.cpp:      DLL.
//

#include "stdafx.h"
#include "Locker.h"



static CRITICAL_SECTION Guard;


bool InitializeGV()
{
#ifdef DEBUG
	OutputDebugString(_T("========> InitializeGV, ClientCount = "));
	OutputDebugString(DataConvertor::ToString(gClientCount));
	OutputDebugString(_T(", Innitialized =  "));
	OutputDebugString(DataConvertor::ToString((int)Innitialized));
	if(pIGVData == NULL)
	{
		OutputDebugString(_T(", pIGVData = NULL "));
	}
	OutputDebugString(_T("\n"));
#endif
	if(!Innitialized)
	{	
		Innitialized = true;
		::InitializeCriticalSection(&Guard);
		Locker locker(Guard);
		CoInitialize(NULL);
		HRESULT hr = 	CoCreateInstance(CLSID_CGlobalVariable, NULL, CLSCTX_INPROC, IID_IGVData,(void**) &pIGVData);
		if(!SUCCEEDED(hr))
		{
			Innitialized = false;
			#ifdef DEBUG
			assert(false);
			#endif
		}
	}

	Locker locker(Guard);
	if(Innitialized)
		gClientCount++;

#ifdef DEBUG
	OutputDebugString(_T("<======== InitializeGV\n"));
#endif
	return Innitialized;
}

void UninitializeGV()
{
#ifdef DEBUG
	OutputDebugString(_T("========> UninitializeGV, ClientCount = "));
	OutputDebugString(DataConvertor::ToString(gClientCount));
	OutputDebugString(_T(", Innitialized =  "));
	OutputDebugString(DataConvertor::ToString((int)Innitialized));
	if(pIGVData == NULL)
	{
		OutputDebugString(_T(", pIGVData = NULL "));
	}
	OutputDebugString(_T("\n"));
#endif
	{
		Locker locker(Guard);
		gClientCount--;
	}

	if(gClientCount == 0 && pIGVData != NULL)
	{
		pIGVData = NULL;
		CoUninitialize();
		::DeleteCriticalSection(&Guard);
		Innitialized = false;
	}

#ifdef DEBUG
	OutputDebugString(_T("<======== UninitializeGV\n"));
#endif
}

bool SetDataInt(wchar_t * VarName, int _val)
{
	Locker locker(Guard);
	CString _t;
	_t.SetString(VarName);
	if(pIGVData != NULL)
	{
		return  pIGVData->SetDataInt(_t, _val);
	}
	return false;
}

int GetDataInt(wchar_t * VarName)
{
	Locker locker(Guard);
	if(pIGVData != NULL)
	{
		return pIGVData->GetDataInt(CString(VarName));
	}
	return INT32_MAX;
}

bool SetDataLong(wchar_t * VarName, long _val)
{
	Locker locker(Guard);
	CString _t;
	_t.SetString(VarName);
	if(pIGVData != NULL)
	{
		return  pIGVData->SetDataLong(_t, _val);
	}
	return false;
}

long GetDataLong(wchar_t * VarName)
{
	Locker locker(Guard);
	if(pIGVData != NULL)
	{
		return pIGVData->GetDataLong(CString(VarName));
	}
	return LONG_MAX;
}

bool SetDataFloat(wchar_t * VarName, float _val)
{
	Locker locker(Guard);
	CString _t;
	_t.SetString(VarName);
	if(pIGVData != NULL)
	{
		return  pIGVData->SetDataFloat(_t, _val);
	}
	return false;
}

float GetDataFloat(wchar_t * VarName)
{
	Locker locker(Guard);
	if(pIGVData != NULL)
	{
		return pIGVData->GetDataFloat(CString(VarName));
	}
	return FLT_MAX;
}

bool SetDataDouble(wchar_t * VarName, double _val)
{
	Locker locker(Guard);
	CString _t;
	_t.SetString(VarName);
	if(pIGVData != NULL)
	{
		return  pIGVData->SetDataDouble(_t, _val);
	}
	return false;
}

double GetDataDouble(wchar_t * VarName)
{
	Locker locker(Guard);
	if(pIGVData != NULL)
	{
		return pIGVData->GetDataDouble(CString(VarName));
	}
	return DBL_MAX;
}

bool SetDataString(wchar_t * VarName, wchar_t * _val)
{
	Locker locker(Guard);
	CString _t;
	_t.SetString(VarName);
	if(pIGVData != NULL)
	{
		return  pIGVData->SetDataString(_t, _val);
	}
	return false;
}

wchar_t * GetDataString(wchar_t * VarName)
{
	Locker locker(Guard);
	if(pIGVData != NULL)
	{
		return (wchar_t *) pIGVData->GetDataString(CString(VarName)).GetString();
	}
	return _T("");
}