#include "StdAfx.h"
#include "BinaryLoader.h"



BinaryLoader::BinaryLoader(CString logfilename)
{
	hFile = CreateFile(logfilename,    //  
		GENERIC_READ,          //   
		FILE_SHARE_READ,       //   
		NULL,                  //   
		OPEN_ALWAYS,
		FILE_ATTRIBUTE_NORMAL, //  
		NULL);

	if (hFile == INVALID_HANDLE_VALUE) 
	{ 
		assert(false);
	}
}


BinaryLoader::~BinaryLoader(void)
{
	Close();
}

int BinaryLoader::ReadInt()
{
	VARIANT v;
	::VariantInit(&v);

	DWORD res = 0;
	BOOL bres = ReadFile(hFile, &v.bVal, sizeof(int), &res, NULL);
	assert(bres);
	return v.bVal;
}

long BinaryLoader::ReadLong()
{
	VARIANT v;
	::VariantInit(&v);

	DWORD res = 0;
	BOOL bres = ReadFile(hFile, &v.lVal, sizeof(long), &res, NULL);
	assert(bres);
	return v.lVal;
}

float BinaryLoader::ReadFloat()
{
	VARIANT v;
	::VariantInit(&v);
	DWORD res = 0;
	BOOL bres = ReadFile(hFile, &v.fltVal, sizeof(float), &res, NULL);
	assert(bres);
	return v.fltVal;
}

double BinaryLoader::ReadDouble()
{
	VARIANT v;
	::VariantInit(&v);
	DWORD res = 0;
	BOOL bres = ReadFile(hFile, &v.dblVal, sizeof(double), &res, NULL);
	assert(bres);
	return v.dblVal;
}

long long BinaryLoader::Read_INT64()
{
	VARIANT v;
	::VariantInit(&v);
	DWORD res = 0;
	BOOL bres = ReadFile(hFile, &v.llVal, sizeof(long long), &res, NULL);
	assert(bres);
	return v.llVal;
}

bool BinaryLoader::ReadBool()
{
	VARIANT v;
	::VariantInit(&v);
	DWORD res = 0;
	BOOL bres = ReadFile(hFile, &v.bVal, sizeof(bool), &res, NULL);
	assert(bres);
	return v.bVal;
}

void BinaryLoader::Close()
{
	if(hFile != INVALID_HANDLE_VALUE)
	{
		BOOL res = CloseHandle(hFile);
		assert(res != 0);
		hFile = INVALID_HANDLE_VALUE;
	}
}

