#pragma once

#include <ObjBase.h>
#include <BaseTyps.h>
#include <atlstr.h>

interface IGVData: public IUnknown
{
	virtual bool SetDataInt(CString name, int _value) = 0;
	virtual int GetDataInt(CString name) = 0;

	virtual bool SetDataLong(CString name, long _value) = 0;
	virtual long GetDataLong(CString name) = 0;

	virtual bool SetDataFloat(CString name, float _value) = 0;
	virtual float GetDataFloat(CString name) = 0;

	virtual bool SetDataDouble(CString name, double _value) = 0;
	virtual double GetDataDouble(CString name) = 0;

	virtual bool SetDataString(CString name, CString _value) = 0;
	virtual CString GetDataString(CString name) = 0;

};

extern "C"
{
	extern const IID IID_IGVData;
	extern const CLSID CLSID_CGlobalVariable;
};


static HMODULE g_hModule = NULL ;   // DLL module handle
static long g_cComponents = 0 ;     // Count of active components
static long g_cServerLocks = 0 ;    // Count of locks